Index: LMDZ5/trunk/libf/phylmd/rrtm/aeropt_6bands_rrtm.F90
===================================================================
--- LMDZ5/trunk/libf/phylmd/rrtm/aeropt_6bands_rrtm.F90	(revision 2644)
+++ LMDZ5/trunk/libf/phylmd/rrtm/aeropt_6bands_rrtm.F90	(revision 2735)
@@ -3,8 +3,6 @@
 !
 SUBROUTINE AEROPT_6BANDS_RRTM ( &
-     pdel, m_allaer, RHcl, &
-     tau_allaer, piz_allaer, &
-     cg_allaer, m_allaer_pi, &
-     flag_aerosol, flag_bc_internal_mixture, zrho )
+     pdel, m_allaer, RHcl, tau_allaer, piz_allaer, &
+     cg_allaer, m_allaer_pi, flag_aerosol, flag_bc_internal_mixture, zrho )
 
   USE dimphy
@@ -53,7 +51,8 @@
   INTEGER, PARAMETER :: nb_level=19 ! number of vertical levels in DATA
 
-  INTEGER, PARAMETER :: naero_soluble=7    ! 1- BC soluble; 2- POM soluble; 3- SO4. acc. 4- SO4 coarse
-                                           ! 5- seasalt super coarse  6- seasalt coarse   7- seasalt acc.
-  INTEGER, PARAMETER :: naero_insoluble=3  ! 1- Dust; 2- BC insoluble; 3- POM insoluble
+  INTEGER, PARAMETER :: naero_soluble=9    ! 1- BC soluble; 2- POM soluble; 3- SO4. acc. 4- SO4 coarse
+                                           ! 5- seasalt super coarse  6- seasalt coarse  7- seasalt acc.
+                                           ! 8- NO3 coarse 9- NO3 acc.
+  INTEGER, PARAMETER :: naero_insoluble=4  ! 1- Dust; 2- BC insoluble; 3- POM insoluble; 4- NO3 insoluble
 
   INTEGER, PARAMETER :: nbre_RH=12
@@ -67,12 +66,12 @@
   REAL :: fac
   REAL :: zdh(klon,klev) 
-  INTEGER, ALLOCATABLE, DIMENSION(:)   :: aerosol_name
+  INTEGER, ALLOCATABLE, DIMENSION(:) :: aerosol_name
   INTEGER :: nb_aer
 
-  REAL, DIMENSION(klon,klev,naero_tot,nbands_sw_rrtm) ::  tau_ae
-  REAL, DIMENSION(klon,klev,naero_tot,nbands_sw_rrtm) ::  piz_ae
-  REAL, DIMENSION(klon,klev,naero_tot,nbands_sw_rrtm) ::  cg_ae
-
-  REAL, DIMENSION(klon,klev,naero_tot,nbands_sw_rrtm) ::  tau_ae_pi
+  REAL, DIMENSION(klon,klev,naero_tot,nbands_sw_rrtm) :: tau_ae
+  REAL, DIMENSION(klon,klev,naero_tot,nbands_sw_rrtm) :: piz_ae
+  REAL, DIMENSION(klon,klev,naero_tot,nbands_sw_rrtm) :: cg_ae
+
+  REAL, DIMENSION(klon,klev,naero_tot,nbands_sw_rrtm) :: tau_ae_pi
   REAL, DIMENSION(klon,klev,id_ASBCM_phy:id_ASBCM_phy,nbands_sw_rrtm) :: piz_ae_pi
   REAL, DIMENSION(klon,klev,id_ASBCM_phy:id_ASBCM_phy,nbands_sw_rrtm) :: cg_ae_pi
@@ -80,16 +79,16 @@
   ! Proprietes optiques
   !
-  REAL:: alpha_aers_6bands(nbre_RH,nbands_sw_rrtm,naero_soluble)   !--unit m2/g SO4
-  REAL:: alpha_aeri_6bands(nbands_sw_rrtm,naero_insoluble)
-  REAL:: cg_aers_6bands(nbre_RH,nbands_sw_rrtm,naero_soluble)      !--unit 
-  REAL:: cg_aeri_6bands(nbands_sw_rrtm,naero_insoluble)
-  REAL:: piz_aers_6bands(nbre_RH,nbands_sw_rrtm,naero_soluble)     !-- unit
-  REAL:: piz_aeri_6bands(nbands_sw_rrtm,naero_insoluble)        !-- unit
+  REAL:: alpha_aers_6bands(nbre_RH,nbands_sw_rrtm,naero_soluble) !--unit m2/g
+  REAL:: alpha_aeri_6bands(nbands_sw_rrtm,naero_insoluble)       !--unit m2/g
+  REAL:: cg_aers_6bands(nbre_RH,nbands_sw_rrtm,naero_soluble)    !--unitless
+  REAL:: cg_aeri_6bands(nbands_sw_rrtm,naero_insoluble)          !--unitless
+  REAL:: piz_aers_6bands(nbre_RH,nbands_sw_rrtm,naero_soluble)   !-- unitless
+  REAL:: piz_aeri_6bands(nbands_sw_rrtm,naero_insoluble)         !-- unitless
   ! 
   ! BC internal mixture
   !
   INTEGER, PARAMETER ::  nbclassbc = 5  ! Added by Rong Wang/OB for the 5 fractions
-                                       ! of BC in the soluble mode:
-                                       ! bc_content/0.001, 0.01, 0.02, 0.05, 0.1/
+                                        ! of BC in the soluble mode:
+                                        ! bc_content/0.001, 0.01, 0.02, 0.05, 0.1/
   ! for Maxwell-Garnet internal mixture
   ! Detailed theory can be found in R. Wang Estimation of global black carbon direct
@@ -126,4 +125,11 @@
   0.377, 0.377, 0.377, 0.377, 0.377, 0.415, 0.456, 0.542, 0.627, 0.636, 0.646, 0.738, &
   0.052, 0.052, 0.052, 0.052, 0.052, 0.057, 0.063, 0.075, 0.087, 0.088, 0.089, 0.102, &
+       ! sulfate coarse CS
+  0.693, 0.693, 0.693, 0.764, 0.839, 0.917, 0.999, 1.136, 1.510, 1.879, 1.879, 3.356, &
+  0.693, 0.693, 0.693, 0.764, 0.839, 0.917, 0.999, 1.136, 1.510, 1.879, 1.879, 3.356, &
+  0.715, 0.715, 0.715, 0.788, 0.865, 0.945, 1.029, 1.171, 1.557, 1.936, 1.936, 3.459, &
+  0.736, 0.736, 0.736, 0.811, 0.891, 0.973, 1.060, 1.206, 1.603, 1.994, 1.994, 3.563, &
+  0.711, 0.711, 0.711, 0.783, 0.860, 0.939, 1.023, 1.164, 1.548, 1.925, 1.925, 3.439, &
+  0.602, 0.602, 0.602, 0.664, 0.729, 0.796, 0.867, 0.986, 1.312, 1.631, 1.631, 2.915, &
        ! sulfate AS   
   6.554, 6.554, 6.554, 7.223, 7.931, 8.665, 9.438,10.736,14.275,17.755,17.755,31.722, &
@@ -133,12 +139,5 @@
   0.312, 0.312, 0.312, 0.344, 0.378, 0.413, 0.450, 0.511, 0.680, 0.846, 0.846, 1.511, &
   0.121, 0.121, 0.121, 0.134, 0.147, 0.161, 0.175, 0.199, 0.264, 0.329, 0.329, 0.588, &
-       ! sulfate coarse CS
-  0.693, 0.693, 0.693, 0.764, 0.839, 0.917, 0.999, 1.136, 1.510, 1.879, 1.879, 3.356, &
-  0.693, 0.693, 0.693, 0.764, 0.839, 0.917, 0.999, 1.136, 1.510, 1.879, 1.879, 3.356, &
-  0.715, 0.715, 0.715, 0.788, 0.865, 0.945, 1.029, 1.171, 1.557, 1.936, 1.936, 3.459, &
-  0.736, 0.736, 0.736, 0.811, 0.891, 0.973, 1.060, 1.206, 1.603, 1.994, 1.994, 3.563, &
-  0.711, 0.711, 0.711, 0.783, 0.860, 0.939, 1.023, 1.164, 1.548, 1.925, 1.925, 3.439, &
-  0.602, 0.602, 0.602, 0.664, 0.729, 0.796, 0.867, 0.986, 1.312, 1.631, 1.631, 2.915, &
-        ! seasalt seasalt Super Coarse Soluble (SS)
+        ! Seasalt Super Coarse Soluble (SS)
   0.214, 0.267, 0.287, 0.310, 0.337, 0.373, 0.421, 0.494, 0.625, 0.742, 0.956, 1.480, &
   0.217, 0.270, 0.291, 0.314, 0.341, 0.377, 0.426, 0.499, 0.632, 0.751, 0.963, 1.490, &
@@ -147,5 +146,5 @@
   0.250, 0.307, 0.330, 0.354, 0.384, 0.424, 0.477, 0.556, 0.696, 0.822, 1.044, 1.592, &
   0.279, 0.347, 0.373, 0.401, 0.434, 0.478, 0.537, 0.625, 0.781, 0.918, 1.158, 1.744, &
-        ! seasalt seasalt Coarse Soluble (CS)      
+        ! Seasalt Coarse Soluble (CS)      
   0.550, 0.676, 0.724, 0.779, 0.841, 0.925, 1.040, 1.213, 1.523, 1.803, 2.306, 3.535, &
   0.568, 0.695, 0.744, 0.798, 0.863, 0.950, 1.066, 1.240, 1.556, 1.839, 2.342, 3.588, &
@@ -154,5 +153,5 @@
   0.663, 0.825, 0.889, 0.957, 1.038, 1.126, 1.268, 1.483, 1.862, 2.196, 2.780, 4.183, &
   0.479, 0.644, 0.711, 0.785, 0.873, 0.904, 1.048, 1.275, 1.692, 2.072, 2.753, 4.430, &
-        ! seasalt seasalt Accumulation Soluble (AS)
+        ! Seasalt Accumulation Soluble (AS)
   6.128, 7.564, 8.127, 8.723, 9.421,10.014,11.250,13.113,16.320,19.061,23.675,34.158, &
   5.080, 6.586, 7.197, 7.856, 8.645, 8.820,10.115,12.140,15.775,18.983,24.499,36.993, &
@@ -160,13 +159,29 @@
   1.389, 2.066, 2.371, 2.719, 3.161, 2.970, 3.623, 4.747, 7.064, 9.419,14.120,27.565, &
   0.309, 0.497, 0.587, 0.693, 0.832, 0.777, 0.986, 1.364, 2.207, 3.136, 5.174,12.065, &
-  0.021, 0.037, 0.045, 0.054, 0.067, 0.065, 0.087, 0.129, 0.230, 0.353, 0.654, 1.885  /
+  0.021, 0.037, 0.045, 0.054, 0.067, 0.065, 0.087, 0.129, 0.230, 0.353, 0.654, 1.885, & 
+        ! NO3 coarse (CS)
+  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,  &
+  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,  &
+  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,  &
+  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,  &
+  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,  &
+  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,  &
+        ! NO3 accumulation (AS)
+  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,  &
+  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,  &
+  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,  &
+  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,  &
+  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,  &
+  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 /
 
   DATA alpha_aeri_6bands/  & 
        ! dust insoluble CI
   0.751, 0.751, 0.769, 0.772, 0.672, 0.437, &
-       ! bc insoluble AI
+       ! BC insoluble AI
   6.497, 6.497, 5.900, 4.284, 2.163, 0.966, &
-       ! pom insoluble AI
-  6.443, 6.443, 4.381, 1.846, 0.377, 0.052 /
+       ! POM insoluble AI
+  6.443, 6.443, 4.381, 1.846, 0.377, 0.052, &
+       ! NO3 insoluble CI
+  0.0, 0.0, 0.0, 0.0, 0.0, 0.0 /
 
   DATA cg_aers_6bands/ &
@@ -185,4 +200,11 @@
   0.363, 0.363, 0.363, 0.363, 0.363, 0.360, 0.357, 0.352, 0.350, 0.349, 0.349, 0.347, &
   0.142, 0.142, 0.142, 0.142, 0.142, 0.139, 0.137, 0.133, 0.131, 0.131, 0.130, 0.129, &
+       ! sulfate coarse CS
+  0.803, 0.803, 0.803, 0.792, 0.783, 0.776, 0.769, 0.758, 0.747, 0.742, 0.738, 0.730, &
+  0.803, 0.803, 0.803, 0.792, 0.783, 0.776, 0.769, 0.758, 0.747, 0.742, 0.738, 0.730, &
+  0.799, 0.799, 0.799, 0.787, 0.777, 0.768, 0.760, 0.747, 0.736, 0.729, 0.725, 0.716, &
+  0.797, 0.797, 0.797, 0.782, 0.770, 0.760, 0.750, 0.735, 0.722, 0.714, 0.709, 0.698, &
+  0.810, 0.810, 0.810, 0.794, 0.781, 0.770, 0.759, 0.743, 0.728, 0.719, 0.714, 0.702, &
+  0.803, 0.803, 0.803, 0.790, 0.779, 0.770, 0.762, 0.748, 0.736, 0.729, 0.725, 0.715, &
        ! sulfate AS 
   0.675, 0.675, 0.675, 0.689, 0.701, 0.711, 0.720, 0.735, 0.748, 0.756, 0.760, 0.771, &
@@ -192,11 +214,4 @@
   0.362, 0.362, 0.362, 0.359, 0.356, 0.354, 0.352, 0.348, 0.345, 0.343, 0.342, 0.340, &
   0.137, 0.137, 0.137, 0.135, 0.133, 0.132, 0.130, 0.128, 0.126, 0.125, 0.124, 0.122, &
-       ! sulfate coarse CS
-  0.803, 0.803, 0.803, 0.792, 0.783, 0.776, 0.769, 0.758, 0.747, 0.742, 0.738, 0.730, &
-  0.803, 0.803, 0.803, 0.792, 0.783, 0.776, 0.769, 0.758, 0.747, 0.742, 0.738, 0.730, &
-  0.799, 0.799, 0.799, 0.787, 0.777, 0.768, 0.760, 0.747, 0.736, 0.729, 0.725, 0.716, &
-  0.797, 0.797, 0.797, 0.782, 0.770, 0.760, 0.750, 0.735, 0.722, 0.714, 0.709, 0.698, &
-  0.810, 0.810, 0.810, 0.794, 0.781, 0.770, 0.759, 0.743, 0.728, 0.719, 0.714, 0.702, &
-  0.803, 0.803, 0.803, 0.790, 0.779, 0.770, 0.762, 0.748, 0.736, 0.729, 0.725, 0.715, &
         ! seasalt seasalt Super Coarse Soluble (SS)
   0.797, 0.800, 0.801, 0.802, 0.804, 0.822, 0.825, 0.828, 0.832, 0.835, 0.838, 0.843, &
@@ -219,16 +234,32 @@
   0.561, 0.585, 0.593, 0.601, 0.609, 0.637, 0.651, 0.669, 0.691, 0.705, 0.723, 0.745, &
   0.392, 0.427, 0.439, 0.451, 0.464, 0.480, 0.500, 0.526, 0.563, 0.588, 0.621, 0.671, &
-  0.144, 0.170, 0.179, 0.189, 0.201, 0.207, 0.224, 0.248, 0.285, 0.315, 0.359, 0.439 /
+  0.144, 0.170, 0.179, 0.189, 0.201, 0.207, 0.224, 0.248, 0.285, 0.315, 0.359, 0.439, & 
+        ! NO3 coarse (CS)
+  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,  &
+  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,  &
+  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,  &
+  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,  &
+  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,  &
+  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,  &
+        ! NO3 accumulation (AS)
+  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,  &
+  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,  &
+  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,  &
+  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,  &
+  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,  &
+  0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0 /
 
   DATA cg_aeri_6bands/ &
        ! dust insoluble CI
   0.718, 0.718, 0.699, 0.661, 0.676, 0.670, &
-       ! bc insoluble AI
+       ! BC insoluble AI
   0.721, 0.721, 0.643, 0.513, 0.321, 0.153, &
-       ! pom insoluble AI
-  0.687, 0.687, 0.658, 0.564, 0.363, 0.142  /
+       ! POM insoluble AI
+  0.687, 0.687, 0.658, 0.564, 0.363, 0.142, &
+       ! NO3 insoluble CI
+  0.0, 0.0, 0.0, 0.0, 0.0, 0.0 /
 
   DATA piz_aers_6bands/&
-       ! bc soluble AS
+       ! BC soluble AS
   0.460, 0.460, 0.460, 0.460, 0.460, 0.534, 0.594, 0.688, 0.748, 0.754, 0.760, 0.803, &
   0.460, 0.460, 0.460, 0.460, 0.460, 0.534, 0.594, 0.688, 0.748, 0.754, 0.760, 0.803, &
@@ -244,4 +275,11 @@
   0.816, 0.816, 0.816, 0.816, 0.816, 0.839, 0.859, 0.888, 0.908, 0.910, 0.911, 0.925, &
   0.663, 0.663, 0.663, 0.663, 0.663, 0.607, 0.562, 0.492, 0.446, 0.441, 0.437, 0.404, &
+       ! sulfate coarse CS
+  1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, &
+  1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, &
+  1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, &
+  1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, &
+  0.996, 0.996, 0.996, 0.996, 0.996, 0.996, 0.996, 0.996, 0.996, 0.996, 0.996, 0.996, &
+  0.877, 0.877, 0.877, 0.873, 0.870, 0.867, 0.864, 0.860, 0.856, 0.854, 0.852, 0.849, &
        ! sulfate AS
   1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, &
@@ -251,11 +289,4 @@
   0.988, 0.988, 0.988, 0.989, 0.990, 0.990, 0.991, 0.992, 0.993, 0.993, 0.994, 0.994, &
   0.256, 0.256, 0.256, 0.263, 0.268, 0.273, 0.277, 0.284, 0.290, 0.294, 0.296, 0.301, &
-       ! sulfate coarse CS
-  1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, &
-  1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, &
-  1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, &
-  1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, &
-  0.996, 0.996, 0.996, 0.996, 0.996, 0.996, 0.996, 0.996, 0.996, 0.996, 0.996, 0.996, &
-  0.877, 0.877, 0.877, 0.873, 0.870, 0.867, 0.864, 0.860, 0.856, 0.854, 0.852, 0.849, &
         ! seasalt seasalt Super Coarse Soluble (SS)
   0.983, 0.982, 0.982, 0.982, 0.982, 0.992, 0.993, 0.994, 0.995, 0.996, 0.997, 0.998, &
@@ -278,13 +309,29 @@
   0.999, 0.999, 0.999, 0.999, 0.999, 0.999, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, &
   0.997, 0.998, 0.998, 0.998, 0.998, 0.999, 0.999, 0.999, 1.000, 1.000, 1.000, 1.000, &
-  0.985, 0.989, 0.990, 0.990, 0.991, 0.996, 0.997, 0.998, 0.999, 0.999, 0.999, 1.000 /
+  0.985, 0.989, 0.990, 0.990, 0.991, 0.996, 0.997, 0.998, 0.999, 0.999, 0.999, 1.000,  &
+        ! NO3 coarse (CS)
+  1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0,  &
+  1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0,  &
+  1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0,  &
+  1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0,  &
+  1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0,  &
+  1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0,  &
+        ! NO3 accumulation (AS)
+  1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0,  &
+  1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0,  &
+  1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0,  &
+  1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0,  &
+  1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0,  &
+  1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0, 1.0 /
 
   DATA piz_aeri_6bands/ &
        ! dust insoluble CI
   0.954, 0.954, 0.965, 0.981, 0.996, 0.990, &
-       ! bc insoluble AI
+       ! BC insoluble AI
   0.460, 0.460, 0.445, 0.394, 0.267, 0.121, &
-       ! pom insoluble AI
-  0.973, 0.973, 0.972, 0.940, 0.816, 0.663 /
+       ! POM insoluble AI
+  0.973, 0.973, 0.972, 0.940, 0.816, 0.663, & 
+       ! NO3 insoluble CI
+  1.0, 1.0, 1.0, 1.0, 1.0, 1.0 /
 
 ! Added by R. Wang (July 31 2016)
@@ -440,5 +487,5 @@
      aerosol_name(1) = id_CIDUSTM_phy
   ELSEIF (flag_aerosol .EQ. 6) THEN 
-     nb_aer = 10
+     nb_aer = 13
      ALLOCATE (aerosol_name(nb_aer)) 
      aerosol_name(1) = id_ASSO4M_phy      
@@ -452,4 +499,7 @@
      aerosol_name(9) = id_CIDUSTM_phy
      aerosol_name(10)= id_CSSO4M_phy
+     aerosol_name(11)= id_CSNO3M_phy
+     aerosol_name(12)= id_ASNO3M_phy
+     aerosol_name(13)= id_CINO3M_phy
   ENDIF
 
@@ -491,9 +541,9 @@
         soluble=.TRUE.
         spsol=2 
-     ELSEIF (aerosol_name(m).EQ.id_ASSO4M_phy) THEN 
+     ELSEIF (aerosol_name(m).EQ.id_CSSO4M_phy) THEN 
         soluble=.TRUE.
         spsol=3
         fac=1.375    ! (NH4)2-SO4/SO4 132/96 mass conversion factor for AOD
-     ELSEIF  (aerosol_name(m).EQ.id_CSSO4M_phy) THEN
+     ELSEIF (aerosol_name(m).EQ.id_ASSO4M_phy) THEN
         soluble=.TRUE.
         spsol=4
@@ -508,4 +558,12 @@
          soluble=.TRUE.
          spsol=7
+     ELSEIF (aerosol_name(m).EQ.id_CSNO3M_phy) THEN
+         soluble=.TRUE.
+         spsol=8
+         fac=1.2903    ! NO3NH4/NO3 / mass conversion factor for AOD
+     ELSEIF (aerosol_name(m).EQ.id_ASNO3M_phy) THEN
+         soluble=.TRUE.
+         spsol=9
+         fac=1.2903    ! NO3NH4/NO3 / mass conversion factor for AOD
      ELSEIF (aerosol_name(m).EQ.id_CIDUSTM_phy) THEN 
          soluble=.FALSE.
@@ -517,4 +575,8 @@
          soluble=.FALSE.
          spinsol=3
+     ELSEIF (aerosol_name(m).EQ.id_CINO3M_phy) THEN 
+         soluble=.FALSE.
+         spinsol=4
+         fac=1.2903    ! NO3NH4/NO3 / mass conversion factor for AOD
      ELSE 
          CYCLE