Index: /LMDZ5/trunk/DefLists/context_lmdz.xml
===================================================================
--- /LMDZ5/trunk/DefLists/context_lmdz.xml	(revision 2750)
+++ /LMDZ5/trunk/DefLists/context_lmdz.xml	(revision 2751)
@@ -21,4 +21,5 @@
   <file_definition src="./file_def_histdayCOSP_lmdz.xml"/>
   <file_definition src="./file_def_histhfCOSP_lmdz.xml"/>
+  <file_definition src="./file_def_histstrataer_lmdz.xml"/>
   
   <!-- Define domains and groups of domains -->
Index: /LMDZ5/trunk/DefLists/field_def_lmdz.xml
===================================================================
--- /LMDZ5/trunk/DefLists/field_def_lmdz.xml	(revision 2750)
+++ /LMDZ5/trunk/DefLists/field_def_lmdz.xml	(revision 2751)
@@ -618,17 +618,17 @@
 
     <field_group id="fields_strataer_3D" domain_ref="dom_glo" axis_ref="presnivs">
-        <field id="ext_strat_550"      long_name="Strat. aerosol extinction coefficient at 550 nm"       unit="1/m" />
-        <field id="ext_strat_1020"     long_name="Strat. aerosol extinction coefficient at 1020 nm"      unit="1/m" />
-        <field id="sulf_convert"       long_name="SO2 mass flux converted to H2SO4"                      unit="kg(S)/m2/layer/s" />
-        <field id="sulf_nucl"          long_name="H2SO4 nucleation mass flux"                            unit="kg(S)/m2/layer/s" />
-        <field id="sulf_cond_evap"     long_name="H2SO4 condensation/evaporation mass flux"              unit="kg(S)/m2/layer/s" />
-        <field id="ocs_convert"        long_name="OCS mass flux converted to SO2"                        unit="kg(S)/m2/layer/s" />
-        <field id="R2SO4"              long_name="H2SO4 mass fraction in aerosol"                        unit="%" />
-        <field id="OCS_lifetime"       long_name="OCS lifetime"                                          unit="s" />
-        <field id="SO2_lifetime"       long_name="SO2 lifetime"                                          unit="s" />
-        <field id="SO2_backgr_tend"    long_name="SO2 background tendency"                               unit="kg(S)/m2/layer/s" />
-        <field id="OCS_backgr_tend"    long_name="OCS background tendency"                               unit="kg(S)/m2/layer/s" />
-        <field id="vsed_aer"           long_name="Strat. aerosol sedimentation velocity (mass-weighted)" unit="m/s" />
-        <field id="f_r_wet"            long_name="Conversion factor dry to wet aerosol radius"           unit="-" />
+        <field id="ext_strat_550"        long_name="Strat. aerosol extinction coefficient at 550 nm"       unit="1/m" />
+        <field id="ext_strat_1020"       long_name="Strat. aerosol extinction coefficient at 1020 nm"      unit="1/m" />
+        <field id="budg_3D_nucl"         long_name="H2SO4 nucleation mass flux"                            unit="kg(S)/m2/layer/s" />
+        <field id="budg_3D_cond_evap"    long_name="H2SO4 net condensation/evaporation mass flux"          unit="kg(S)/m2/layer/s" />
+        <field id="budg_3D_ocs_to_so2"   long_name="OCS mass flux converted to SO2"                        unit="kg(S)/m2/layer/s" />
+        <field id="budg_3D_so2_to_h2so4" long_name="SO2 mass flux converted to H2SO4"                      unit="kg(S)/m2/layer/s" />
+        <field id="budg_3D_backgr_ocs"   long_name="OCS background tendency"                               unit="kg(S)/m2/layer/s" />
+        <field id="budg_3D_backgr_so2"   long_name="SO2 background tendency"                               unit="kg(S)/m2/layer/s" />
+        <field id="R2SO4"                long_name="H2SO4 mass fraction in aerosol"                        unit="%" />
+        <field id="OCS_lifetime"         long_name="OCS lifetime"                                          unit="s" />
+        <field id="SO2_lifetime"         long_name="SO2 lifetime"                                          unit="s" />
+        <field id="vsed_aer"             long_name="Strat. aerosol sedimentation velocity (mass-weighted)" unit="m/s" />
+        <field id="f_r_wet"              long_name="Conversion factor dry to wet aerosol radius"           unit="-" />
     </field_group>
 
@@ -636,9 +636,18 @@
         <field id="OD550_strat_only"   long_name="Stratospheric Aerosol Optical depth at 550 nm "        unit="1" />
         <field id="OD1020_strat_only"  long_name="Stratospheric Aerosol Optical depth at 1020 nm "       unit="1" />
-        <field id="sulf_dep_dry"       long_name="Sulfur dry deposition flux"                            unit="kg(S)/m2/s" />
-        <field id="sulf_dep_wet"       long_name="Sulfur wet deposition flux"                            unit="kg(S)/m2/s" />
         <field id="surf_PM25_sulf"     long_name="Sulfate PM2.5 concentration at the surface"            unit="ug/m3" />
         <field id="p_tropopause"       long_name="Tropopause pressure"                                   unit="Pa" />
-        <field id="sflux"              long_name="Ground sedimentation flux of strat. particles"         unit="kg(S)/m2/s" />
+        <field id="budg_dep_dry_h2so4" long_name="H2SO4 dry deposition flux"                             unit="kg(S)/m2/s" />
+        <field id="budg_dep_wet_h2so4" long_name="H2SO4 wet deposition flux"                             unit="kg(S)/m2/s" />
+        <field id="budg_dep_dry_part"  long_name="Particle S dry deposition flux"                        unit="kg(S)/m2/s" />
+        <field id="budg_dep_wet_part"  long_name="Particle S wet deposition flux"                        unit="kg(S)/m2/s" />
+        <field id="budg_emi_ocs"       long_name="OCS emission flux"                                     unit="kg(S)/m2/s" />
+        <field id="budg_emi_so2"       long_name="SO2 emission flux"                                     unit="kg(S)/m2/s" />
+        <field id="budg_emi_h2so4"     long_name="H2SO4 emission flux"                                   unit="kg(S)/m2/s" />
+        <field id="budg_emi_part"      long_name="Particle S emission flux"                              unit="kg(S)/m2/s" />
+        <field id="budg_ocs_to_so2"    long_name="OCS to SO2 conversion flux"                            unit="kg(S)/m2/s" />
+        <field id="budg_so2_to_h2so4"  long_name="SO2 to H2SO4 conversion flux"                          unit="kg(S)/m2/s" />
+        <field id="budg_h2so4_to_part" long_name="H2SO4 to particle conversion flux"                     unit="kg(S)/m2/s" />
+        <field id="budg_sed_part"      long_name="Ground sedimentation flux of strat. particles"         unit="kg(S)/m2/s" />
     </field_group>
     
Index: /LMDZ5/trunk/DefLists/file_def_histmth_lmdz.xml
===================================================================
--- /LMDZ5/trunk/DefLists/file_def_histmth_lmdz.xml	(revision 2750)
+++ /LMDZ5/trunk/DefLists/file_def_histmth_lmdz.xml	(revision 2751)
@@ -600,9 +600,4 @@
             </field_group>
 
-            <field_group group_ref="fields_strataer_3D" operation="average" freq_op="1ts" level="1" />
-            <field_group group_ref="fields_strataer_2D" operation="average" freq_op="1ts" level="1" />
-            <field_group group_ref="fields_strataer_trac_3D" operation="average" freq_op="1ts" level="1" />
-            <field_group group_ref="fields_strataer_trac_2D" operation="average" freq_op="1ts" level="1" />
-
         </file>
 