Index: /LMDZ5/trunk/DefLists/field_def_lmdz.xml
===================================================================
--- /LMDZ5/trunk/DefLists/field_def_lmdz.xml	(revision 2841)
+++ /LMDZ5/trunk/DefLists/field_def_lmdz.xml	(revision 2842)
@@ -338,5 +338,5 @@
         <field id="od550aer"    long_name="Total aerosol optical depth at 550nm"    unit="-" />
         <field id="od865aer"    long_name="Total aerosol optical depth at 870nm"    unit="-" />
-        <field id="absvisaer"    long_name="Absorption aerosol visible optical depth"    unit="-" />
+        <field id="abs550aer"    long_name="Absorption aerosol optical depth at 550nm"    unit="-" />
         <field id="od550lt1aer"    long_name="Fine mode optical depth"    unit="-" />
         <field id="sconcso4"    long_name="Surface Concentration of Sulfate "    unit="kg/m3" />
Index: /LMDZ5/trunk/DefLists/file_def_histLES_lmdz.xml
===================================================================
--- /LMDZ5/trunk/DefLists/file_def_histLES_lmdz.xml	(revision 2841)
+++ /LMDZ5/trunk/DefLists/file_def_histLES_lmdz.xml	(revision 2842)
@@ -337,5 +337,5 @@
                 <field field_ref="od550aer" level="10" />
                 <field field_ref="od865aer" level="10" />
-                <field field_ref="absvisaer" level="10" />
+                <field field_ref="abs550aer" level="10" />
                 <field field_ref="od550lt1aer" level="10" />
                 <field field_ref="sconcso4" level="10" />
Index: /LMDZ5/trunk/DefLists/file_def_histday_lmdz.xml
===================================================================
--- /LMDZ5/trunk/DefLists/file_def_histday_lmdz.xml	(revision 2841)
+++ /LMDZ5/trunk/DefLists/file_def_histday_lmdz.xml	(revision 2842)
@@ -343,5 +343,5 @@
                 <field field_ref="od550aer" level="6" />
                 <field field_ref="od865aer" level="6" />
-                <field field_ref="absvisaer" level="6" />
+                <field field_ref="abs550aer" level="6" />
                 <field field_ref="od550lt1aer" level="6" />
                 <field field_ref="sconcso4" level="6" />
Index: /LMDZ5/trunk/DefLists/file_def_histhf_lmdz.xml
===================================================================
--- /LMDZ5/trunk/DefLists/file_def_histhf_lmdz.xml	(revision 2841)
+++ /LMDZ5/trunk/DefLists/file_def_histhf_lmdz.xml	(revision 2842)
@@ -337,5 +337,5 @@
                 <field field_ref="od550aer" level="10" />
                 <field field_ref="od865aer" level="10" />
-                <field field_ref="absvisaer" level="10" />
+                <field field_ref="abs550aer" level="10" />
                 <field field_ref="od550lt1aer" level="10" />
                 <field field_ref="sconcso4" level="10" />
Index: /LMDZ5/trunk/DefLists/file_def_histins_lmdz.xml
===================================================================
--- /LMDZ5/trunk/DefLists/file_def_histins_lmdz.xml	(revision 2841)
+++ /LMDZ5/trunk/DefLists/file_def_histins_lmdz.xml	(revision 2842)
@@ -337,5 +337,5 @@
                 <field field_ref="od550aer" level="10" />
                 <field field_ref="od865aer" level="10" />
-                <field field_ref="absvisaer" level="10" />
+                <field field_ref="abs550aer" level="10" />
                 <field field_ref="od550lt1aer" level="10" />
                 <field field_ref="sconcso4" level="10" />
Index: /LMDZ5/trunk/DefLists/file_def_histmth_lmdz.xml
===================================================================
--- /LMDZ5/trunk/DefLists/file_def_histmth_lmdz.xml	(revision 2841)
+++ /LMDZ5/trunk/DefLists/file_def_histmth_lmdz.xml	(revision 2842)
@@ -363,5 +363,5 @@
                 <field field_ref="od550aer" level="2" />
                 <field field_ref="od865aer" level="2" />
-                <field field_ref="absvisaer" level="2" />
+                <field field_ref="abs550aer" level="2" />
                 <field field_ref="od550lt1aer" level="2" />
                 <field field_ref="sconcso4" level="2" />
Index: /LMDZ5/trunk/DefLists/file_def_histstn_lmdz.xml
===================================================================
--- /LMDZ5/trunk/DefLists/file_def_histstn_lmdz.xml	(revision 2841)
+++ /LMDZ5/trunk/DefLists/file_def_histstn_lmdz.xml	(revision 2842)
@@ -337,5 +337,5 @@
                 <field field_ref="od550aer" level="10" />
                 <field field_ref="od865aer" level="10" />
-                <field field_ref="absvisaer" level="10" />
+                <field field_ref="abs550aer" level="10" />
                 <field field_ref="od550lt1aer" level="10" />
                 <field field_ref="sconcso4" level="10" />
Index: /LMDZ5/trunk/libf/phylmd/aeropt_2bands.F90
===================================================================
--- /LMDZ5/trunk/libf/phylmd/aeropt_2bands.F90	(revision 2841)
+++ /LMDZ5/trunk/libf/phylmd/aeropt_2bands.F90	(revision 2842)
@@ -10,5 +10,4 @@
   USE dimphy
   USE aero_mod
-  USE phys_local_var_mod, only: absvisaer
   USE pres2lev_mod
 
@@ -1127,10 +1126,4 @@
   ENDDO
 
-  inu=1         ! visible waveband
-  mrfspecies=2  ! total aerosol AER	 
-  DO i=1, KLON
-     absvisaer(i)=SUM((1-piz_allaer(i,:,mrfspecies,inu))*tau_allaer(i,:,mrfspecies,inu))
-  ENDDO
-
   DEALLOCATE(aerosol_name) 
 
Index: /LMDZ5/trunk/libf/phylmd/phys_local_var_mod.F90
===================================================================
--- /LMDZ5/trunk/libf/phylmd/phys_local_var_mod.F90	(revision 2841)
+++ /LMDZ5/trunk/libf/phylmd/phys_local_var_mod.F90	(revision 2842)
@@ -167,6 +167,6 @@
       REAL, SAVE, ALLOCATABLE :: od550aer(:) 
       !$OMP THREADPRIVATE(od550aer) 
-      REAL, SAVE, ALLOCATABLE :: absvisaer(:) 
-      !$OMP THREADPRIVATE(absvisaer) 
+      REAL, SAVE, ALLOCATABLE :: abs550aer(:) 
+      !$OMP THREADPRIVATE(abs550aer) 
       REAL, SAVE, ALLOCATABLE :: od865aer(:) 
       !$OMP THREADPRIVATE(od865aer) 
@@ -579,5 +579,5 @@
       allocate(od550aer(klon))
       allocate(od865aer(klon))
-      allocate(absvisaer(klon))
+      allocate(abs550aer(klon))
       allocate(ec550aer(klon,klev))
       allocate(od550lt1aer(klon))
@@ -838,5 +838,5 @@
       deallocate(od550aer)
       deallocate(od865aer)
-      deallocate(absvisaer)
+      deallocate(abs550aer)
       deallocate(ec550aer)
       deallocate(od550lt1aer)
Index: /LMDZ5/trunk/libf/phylmd/phys_output_ctrlout_mod.F90
===================================================================
--- /LMDZ5/trunk/libf/phylmd/phys_output_ctrlout_mod.F90	(revision 2841)
+++ /LMDZ5/trunk/libf/phylmd/phys_output_ctrlout_mod.F90	(revision 2842)
@@ -1100,6 +1100,6 @@
   TYPE(ctrl_out), SAVE :: o_od865aer = ctrl_out((/ 2, 6, 10, 10, 10, 10, 11, 11, 11, 11/), &
     'od865aer', 'Total aerosol optical depth at 870nm', '-', (/ ('', i=1, 10) /))
-  TYPE(ctrl_out), SAVE :: o_absvisaer = ctrl_out((/ 2, 6, 10, 10, 10, 10, 11, 11, 11, 11/), &
-    'absvisaer', 'Absorption aerosol visible optical depth', '-', (/ ('', i=1, 10) /))
+  TYPE(ctrl_out), SAVE :: o_abs550aer = ctrl_out((/ 2, 6, 10, 10, 10, 10, 11, 11, 11, 11/), &
+    'abs550aer', 'Absorption aerosol optical depth at 550nm', '-', (/ ('', i=1, 10) /))
   TYPE(ctrl_out), SAVE :: o_od550lt1aer = ctrl_out((/ 2, 6, 10, 10, 10, 10, 11, 11, 11, 11/), &
     'od550lt1aer', 'Fine mode optical depth', '-', (/ ('', i=1, 10) /))
Index: /LMDZ5/trunk/libf/phylmd/phys_output_write_mod.F90
===================================================================
--- /LMDZ5/trunk/libf/phylmd/phys_output_write_mod.F90	(revision 2841)
+++ /LMDZ5/trunk/libf/phylmd/phys_output_write_mod.F90	(revision 2842)
@@ -100,5 +100,5 @@
          o_solldown, o_dtsvdfo, o_dtsvdft, &
          o_dtsvdfg, o_dtsvdfi, o_z0m, o_z0h, o_od443aer, o_od550aer, &
-         o_od865aer, o_absvisaer, o_od550lt1aer, &
+         o_od865aer, o_abs550aer, o_od550lt1aer, &
          o_sconcso4, o_sconcno3, o_sconcoa, o_sconcbc, &
          o_sconcss, o_sconcdust, o_concso4, o_concno3, &
@@ -253,5 +253,5 @@
          pmflxr, pmflxs, prfl, psfl, re, fl, rh2m, &
          qsat2m, tpote, tpot, d_ts, od443aer, od550aer, &
-         od865aer, absvisaer, od550lt1aer, sconcso4, sconcno3, &
+         od865aer, abs550aer, od550lt1aer, sconcso4, sconcno3, &
          sconcoa, sconcbc, sconcss, sconcdust, concso4, concno3, &
          concoa, concbc, concss, concdust, loadso4, &
@@ -1173,5 +1173,5 @@
              CALL histwrite_phy(o_od550aer, od550aer)
              CALL histwrite_phy(o_od865aer, od865aer)
-             CALL histwrite_phy(o_absvisaer, absvisaer)
+             CALL histwrite_phy(o_abs550aer, abs550aer)
              CALL histwrite_phy(o_od550lt1aer, od550lt1aer)
              CALL histwrite_phy(o_sconcso4, sconcso4)
Index: /LMDZ5/trunk/libf/phylmd/rrtm/aeropt_5wv_rrtm.F90
===================================================================
--- /LMDZ5/trunk/libf/phylmd/rrtm/aeropt_5wv_rrtm.F90	(revision 2841)
+++ /LMDZ5/trunk/libf/phylmd/rrtm/aeropt_5wv_rrtm.F90	(revision 2842)
@@ -12,5 +12,5 @@
   USE DIMPHY
   USE aero_mod
-  USE phys_local_var_mod, ONLY: od443aer,od550aer,od865aer,ec550aer,od550lt1aer
+  USE phys_local_var_mod, ONLY: od443aer,od550aer,od865aer,ec550aer,od550lt1aer,abs550aer
   USE YOMCST, ONLY: RD,RG
 
@@ -68,5 +68,4 @@
   REAL, DIMENSION(klon,nwave,naero_tot), INTENT(OUT)      :: tausum
   REAL, DIMENSION(klon,klev,nwave,naero_tot), INTENT(OUT) :: tau
-
   !
   ! Local
@@ -95,4 +94,5 @@
   REAL :: delta(klon,klev), rh(klon,klev)
   REAL :: tau_ae5wv_int   ! Intermediate computation of epaisseur optique aerosol
+  REAL :: abs_ae5wv_int   ! Intermediate computation of epaisseur optique aerosol
   REAL :: od670aer(klon)  ! epaisseur optique aerosol extinction 670 nm
   REAL :: fac
@@ -104,5 +104,7 @@
   
   REAL :: alpha_aers_5wv(nbre_RH,las,naero_soluble)   ! Ext. coeff. ** m2/g 
+  REAL :: abs_aers_5wv(nbre_RH,las,naero_soluble)     ! Abs. coeff. ** m2/g 
   REAL :: alpha_aeri_5wv(las,naero_insoluble)         ! Ext. coeff. ** m2/g 
+  REAL :: abs_aeri_5wv(las,naero_insoluble)           ! Abs. coeff. ** m2/g 
 
   !
@@ -117,4 +119,5 @@
   ! Geophys. Res. Atmos. Added by R. Wang and OB
   REAL :: alpha_MG_5wv(nbre_RH,las,nbclassbc)
+  REAL :: abs_MG_5wv(nbre_RH,las,nbclassbc)
 
   !
@@ -191,4 +194,70 @@
    ! Nitrate insoluble
   0.726, 0.753, 0.780, 0.797, 0.811 /
+!
+ DATA abs_aers_5wv/ &
+   ! absorption BC Accumulation Soluble (AS)
+  2.861, 2.861, 2.861, 2.861, 2.861, 3.089, 3.316, 3.767, 4.167, 4.211, 4.255, 4.647, &
+  2.806, 2.806, 2.806, 2.806, 2.806, 3.010, 3.209, 3.597, 3.935, 3.971, 4.008, 4.333, &
+  2.674, 2.674, 2.674, 2.674, 2.674, 2.847, 3.015, 3.335, 3.608, 3.638, 3.667, 3.924, &
+  2.566, 2.566, 2.566, 2.566, 2.566, 2.723, 2.872, 3.155, 3.393, 3.419, 3.444, 3.667, &
+  2.444, 2.444, 2.444, 2.444, 2.444, 2.585, 2.719, 2.968, 3.176, 3.199, 3.221, 3.413, &
+   ! absorption POM Accumulation Soluble (AS)
+  0.170, 0.170, 0.170, 0.170, 0.170, 0.167, 0.165, 0.162, 0.160, 0.160, 0.159, 0.158, &
+  0.145, 0.145, 0.145, 0.145, 0.145, 0.143, 0.142, 0.139, 0.138, 0.138, 0.138, 0.137, &
+  0.125, 0.125, 0.125, 0.125, 0.125, 0.123, 0.122, 0.120, 0.119, 0.119, 0.119, 0.119, &
+  0.131, 0.131, 0.131, 0.131, 0.131, 0.130, 0.129, 0.127, 0.127, 0.127, 0.127, 0.127, &
+  0.133, 0.133, 0.133, 0.133, 0.133, 0.132, 0.131, 0.131, 0.131, 0.131, 0.131, 0.131, &
+  ! absorption Sulfate Coarse Soluble (CS)
+  0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, &
+  0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, &
+  0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, &
+  0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, &
+  0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, &
+   !-- Absorption Sulfate Accumulation (BC content=0)
+  0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, &
+  0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, &
+  0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, &
+  0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, &
+  0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, &
+   ! absorption Seasalt Super Coarse Soluble (SS)
+  0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, &
+  0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, &
+  0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, &
+  0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, &
+  0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, &
+   ! absorption Seasalt Coarse Soluble (CS)
+  0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, &
+  0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, &
+  0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, &
+  0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, &
+  0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, &
+   ! absorption Seasalt Accumulation Soluble (AS)
+  0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, &
+  0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, &
+  0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, &
+  0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, &
+  0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, &
+   ! absorption Nitrate Coarse Soluble (CS)
+  0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, &
+  0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, &
+  0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, &
+  0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, &
+  0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, &
+   ! absorption Nitrate Accumulation Soluble (AS)
+  0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, &
+  0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, &
+  0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, &
+  0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, &
+  0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000  /
+
+ DATA abs_aeri_5wv/ &
+   ! absorption Dust insoluble
+  0.081, 0.048, 0.032, 0.027, 0.019, &
+   ! absorption BC insoluble
+  2.861, 2.806, 2.674, 2.566, 2.444, &
+   ! absorption POM insoluble
+  0.170, 0.145, 0.125, 0.131, 0.133, &
+   ! absorption Nitrate insoluble
+  0.000, 0.000, 0.000, 0.000, 0.000 /
 
 ! Added by R. Wang (July 31 2016)
@@ -232,4 +301,42 @@
    4.505,  4.505,  4.505,  4.505,  4.520,  4.444,  4.356,  4.243,  4.089,  3.997,  3.912,  4.179, &
    4.295,  4.295,  4.295,  4.295,  4.307,  4.239,  4.157,  4.045,  3.876,  3.757,  3.602,  3.569  /
+!
+   DATA abs_MG_5wv/ &
+ !--BC content=0.001
+  13.416, 13.416, 13.416, 13.416, 12.041, 11.928, 11.793, 11.680, 11.488, 11.367, 11.200, 10.968,&
+  10.085, 10.085, 10.085, 10.085,  9.116,  9.061,  8.977,  8.901,  8.778, 8.712,  8.617,  8.474, &
+   7.491,  7.491,  7.491,  7.491,  6.836,  6.808,  6.764,  6.719,  6.659, 6.613,  6.568,  6.508, &
+   6.269,  6.269,  6.269,  6.269,  5.774,  5.761,  5.734,  5.706,  5.665, 5.637,  5.615,  5.579, &
+   5.300,  5.300,  5.300,  5.300,  4.919,  4.913,  4.899,  4.882,  4.863, 4.847,  4.831,  4.825, &
+ !--BC content=0.010
+  12.829, 12.829, 12.829, 12.829, 11.692, 11.618, 11.523, 11.419, 11.278, 11.192, 11.055, 10.850,&
+   9.766,  9.766,  9.766,  9.766,  8.932,  8.890,  8.828,  8.762,  8.671, 8.617,  8.528,  8.411, &
+   7.316,  7.316,  7.316,  7.316,  6.739,  6.716,  6.684,  6.643,  6.597, 6.561,  6.517,  6.465, &
+   6.154,  6.154,  6.154,  6.154,  5.708,  5.696,  5.676,  5.651,  5.624, 5.602,  5.576,  5.543, &
+   5.216,  5.216,  5.216,  5.216,  4.874,  4.870,  4.860,  4.848,  4.835, 4.823,  4.810,  4.800, &
+ !--BC content=0.020
+  12.290, 12.290, 12.290, 12.290, 11.358, 11.315, 11.248, 11.175, 11.073, 11.008, 10.902, 10.743,&
+   9.455,  9.455,  9.455,  9.455,  8.743,  8.716,  8.671,  8.622,  8.556, 8.513,  8.442,  8.349, &
+   7.142,  7.142,  7.142,  7.142,  6.635,  6.621,  6.596,  6.567,  6.532, 6.503,  6.469,  6.428, &
+   6.033,  6.033,  6.033,  6.033,  5.634,  5.629,  5.615,  5.598,  5.578, 5.561,  5.541,  5.517, &
+   5.130,  5.130,  5.130,  5.130,  4.821,  4.821,  4.816,  4.809,  4.801, 4.794,  4.784,  4.781, &
+ !--BC content=0.050
+  10.989, 10.989, 10.989, 10.989, 10.504, 10.523, 10.528, 10.528, 10.522, 10.512, 10.485, 10.445,&
+   8.671,  8.671,  8.671,  8.671,  8.239,  8.249,  8.248,  8.242,  8.233, 8.221,  8.199,  8.176, &
+   6.688,  6.688,  6.688,  6.688,  6.346,  6.354,  6.353,  6.350,  6.346, 6.339,  6.328,  6.322, &
+   5.707,  5.707,  5.707,  5.707,  5.427,  5.437,  5.440,  5.441,  5.444, 5.442,  5.438,  5.444, &
+   4.894,  4.894,  4.894,  4.894,  4.671,  4.682,  4.688,  4.694,  4.702, 4.705,  4.709,  4.726, &
+ !--BC content=0.100
+   9.397,  9.397,  9.397,  9.397,  9.357,  9.443,  9.525,  9.615,  9.725, 9.788,  9.866,  9.991, &
+   7.654,  7.654,  7.654,  7.654,  7.527,  7.581,  7.629,  7.682,  7.746, 7.781,  7.825,  7.901, &
+   6.070,  6.070,  6.070,  6.070,  5.922,  5.956,  5.986,  6.018,  6.057, 6.079,  6.105,  6.156, &
+   5.252,  5.252,  5.252,  5.252,  5.117,  5.146,  5.171,  5.198,  5.231, 5.250,  5.274,  5.322, &
+   4.557,  4.557,  4.557,  4.557,  4.441,  4.466,  4.489,  4.513,  4.544, 4.562,  4.586,  4.634, &
+ !--BC content=0.200
+   7.300,  7.300,  7.300,  7.300,  7.649,  7.799,  7.960,  8.149,  8.397, 8.559,  8.779,  9.149, &
+   6.225,  6.225,  6.225,  6.225,  6.403,  6.504,  6.610,  6.733,  6.893, 6.996,  7.136,  7.372, &
+   5.145,  5.145,  5.145,  5.145,  5.216,  5.282,  5.350,  5.429,  5.530, 5.595,  5.682,  5.833, &
+   4.550,  4.550,  4.550,  4.550,  4.587,  4.640,  4.694,  4.756,  4.836, 4.887,  4.957,  5.079, &
+   4.023,  4.023,  4.023,  4.023,  4.041,  4.084,  4.128,  4.178,  4.244, 4.286,  4.344,  4.447  /
   ! 
   ! Initialisations
@@ -237,4 +344,6 @@
   tausum(:,:,:) = 0.
   tau(:,:,:,:)=0.
+
+  abs550aer(:)=0.0
 
   DO k=1, klev
@@ -396,9 +505,17 @@
              ENDIF
 
-              tau_ae5wv_int = alpha_MG_5wv(RH_num(i,k),la,classbc)+DELTA(i,k)* &
-                             (alpha_MG_5wv(RH_num(i,k)+1,la,classbc) - & 
-                              alpha_MG_5wv(RH_num(i,k),la,classbc))
-              tau(i,k,la,aerindex) = m_allaer(i,k,aerindex)/1.e6*zdh(i,k)*tau_ae5wv_int*fac
-              tausum(i,la,aerindex)=tausum(i,la,aerindex)+tau(i,k,la,aerindex)
+             tau_ae5wv_int = alpha_MG_5wv(RH_num(i,k),la,classbc)+DELTA(i,k)* &
+                            (alpha_MG_5wv(RH_num(i,k)+1,la,classbc) - & 
+                             alpha_MG_5wv(RH_num(i,k),la,classbc))
+             tau(i,k,la,aerindex) = m_allaer(i,k,aerindex)/1.e6*zdh(i,k)*tau_ae5wv_int*fac
+             tausum(i,la,aerindex)=tausum(i,la,aerindex)+tau(i,k,la,aerindex)
+
+             IF (la.EQ.la550) THEN 
+                abs_ae5wv_int = abs_MG_5wv(RH_num(i,k),la,classbc)+DELTA(i,k)* &
+                               (abs_MG_5wv(RH_num(i,k)+1,la,classbc) - & 
+                                abs_MG_5wv(RH_num(i,k),la,classbc))
+                abs550aer(i)=abs550aer(i)+m_allaer(i,k,aerindex)/1.e6*zdh(i,k)*abs_ae5wv_int*fac
+             ENDIF 
+
             ENDDO
           ENDDO
@@ -414,4 +531,12 @@
               tau(i,k,la,aerindex) = m_allaer(i,k,aerindex)/1.e6*zdh(i,k)*tau_ae5wv_int*fac
               tausum(i,la,aerindex)=tausum(i,la,aerindex)+tau(i,k,la,aerindex)
+
+              IF (la.EQ.la550) THEN 
+                 abs_ae5wv_int = abs_aers_5wv(RH_num(i,k),la,spsol)+DELTA(i,k)* &
+                                (abs_aers_5wv(RH_num(i,k)+1,la,spsol) - & 
+                                 abs_aers_5wv(RH_num(i,k),la,spsol))
+                 abs550aer(i)=abs550aer(i)+m_allaer(i,k,aerindex)/1.e6*zdh(i,k)*abs_ae5wv_int*fac
+              ENDIF 
+
             ENDDO
           ENDDO
@@ -424,7 +549,14 @@
         DO k=1, klev
           DO i=1, klon
+
             tau_ae5wv_int = alpha_aeri_5wv(la,spinsol)
             tau(i,k,la,aerindex) = m_allaer(i,k,aerindex)/1.e6*zdh(i,k)*tau_ae5wv_int*fac
             tausum(i,la,aerindex)= tausum(i,la,aerindex)+tau(i,k,la,aerindex)
+
+            IF (la.EQ.la550) THEN 
+               abs_ae5wv_int = abs_aeri_5wv(la,spsol)
+               abs550aer(i)=abs550aer(i)+m_allaer(i,k,aerindex)/1.e6*zdh(i,k)*abs_ae5wv_int*fac
+            ENDIF 
+
           ENDDO
         ENDDO
Index: /LMDZ5/trunk/libf/phylmd/rrtm/aeropt_6bands_rrtm.F90
===================================================================
--- /LMDZ5/trunk/libf/phylmd/rrtm/aeropt_6bands_rrtm.F90	(revision 2841)
+++ /LMDZ5/trunk/libf/phylmd/rrtm/aeropt_6bands_rrtm.F90	(revision 2842)
@@ -10,5 +10,4 @@
   USE dimphy
   USE aero_mod
-  USE phys_local_var_mod, only: absvisaer
   USE YOMCST, ONLY: RG
 
@@ -835,10 +834,4 @@
     ENDDO
    
-!--waveband 2 and all aerosol (third index = 2)
-  inu=2
-  DO i=1, klon
-     absvisaer(i)=SUM((1-piz_allaer(i,:,2,inu))*tau_allaer(i,:,2,inu))
-  ENDDO
-
   DEALLOCATE(aerosol_name) 
 